# -*- coding: utf-8 -*-
#
#  File: invoices.py
#  Module: l10n_ch_vat_on_payment
#
#  Created by cyp@open-net.ch
#
#  Copyright (c) 2010 Open-Net Ltd. All rights reserved.
##############################################################################
#	
#	OpenERP, Open Source Management Solution
#	Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#	This program is free software: you can redistribute it and/or modify
#	it under the terms of the GNU Affero General Public License as
#	published by the Free Software Foundation, either version 3 of the
#	License, or (at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU Affero General Public License for more details.
#
#	You should have received a copy of the GNU Affero General Public License
#	along with this program.  If not, see <http://www.gnu.org/licenses/>.	 
#
##############################################################################

import netsvc
from osv import fields, osv

class account_invoice( osv.osv ):
	_inherit = 'account.invoice'

	def action_move_create(self, cr, uid, ids, *args):
		ret = super(account_invoice, self).action_move_create(cr, uid, ids, args)
		
		for inv in self.browse(cr, uid, ids):
			mv = inv.move_id
			if mv:
				for mvl in mv.line_id:
					if mvl.state == 'valid':
						self.pool.get('account.move.line').write(cr, uid, [mvl.id], {'state':'tva'})
		
		return ret
		
	def write( self, cr, uid, ids, vals, context={} ):
		if isinstance(ids, (int,long)): ids = [ids]
		todos = []
		if vals.get('state', False):
			for row in self.read( cr, uid, ids, ['state','move_id'], context=context ):
				if row['state'] == 'paid':
					todos.append(row['move_id'][0])
		ret = super(account_invoice, self).write( cr, uid, ids, vals, context=context )
		
		if len(todos) > 0:
			move_lines = self.pool.get('account.move.line')
			mvl_ids = move_lines.search( cr, uid, [('move_id','in',todos)], context=context )
			if mvl_ids and len(mvl_ids):
				move_lines.write( cr, uid, mvl_ids, {'state':'tva'}, context=context )
		
		return ret

account_invoice()
