# -*- coding: utf-8 -*-
#
#  File: wizard/account_payment_populate_statement.py
#  Module: l10n_ch_vat_on_payment
#
#  Created by cyp@open-net.ch
#
#  Copyright (c) 2010 Open-Net Ltd. All rights reserved.
##############################################################################
#
#	OpenERP, Open Source Management Solution
#	Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#	This program is free software: you can redistribute it and/or modify
#	it under the terms of the GNU Affero General Public License as
#	published by the Free Software Foundation, either version 3 of the
#	License, or (at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU Affero General Public License for more details.
#
#	You should have received a copy of the GNU Affero General Public License
#	along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import time
from lxml import etree

from osv import osv, fields

class account_payment_populate_statement(osv.osv_memory):
	_inherit = "account.payment.populate.statement"
	def fields_view_get(self, cr, uid, view_id=None, view_type='form', context=None, toolbar=False, submenu=False):
		line_obj = self.pool.get('payment.line')

		res = super(account_payment_populate_statement, self).fields_view_get(cr, uid, view_id=view_id, view_type=view_type, context=context, toolbar=toolbar, submenu=False)
		line_ids = line_obj.search(cr, uid, [
			('move_line_id.reconcile_id', '=', False),
			('bank_statement_line_id', '=', False),
			('move_line_id.state','=','tva'),
			('order_id.state','=','open')])
		line_ids.extend(line_obj.search(cr, uid, [
			('move_line_id.reconcile_id', '=', False),
			('order_id.mode', '=', False),
			('move_line_id.state','=','tva')]))
		domain = '[("id", "in", '+ str(line_ids)+')]'
		doc = etree.XML(res['arch'])
		nodes = doc.xpath("//field[@name='lines']")
		for node in nodes:
			node.set('domain', domain)
		res['arch'] = etree.tostring(doc)
		return res

account_payment_populate_statement()
